#!/usr/bin/python
##### Smerni diagram piramidnega lijaka v log.kartezicnih koordinatah - S53MV 27.12.2017 #####

import math	#uporabljene funkcije

k=0.001		#korak risanja v radianih
s=20.0/math.log(10.0)
h=10.0		#visina lijaka v valovnih dolzinah
w=10.0		#sirina lijaka v valovnih dolzinah

x=[]		#polja za risanje grafa
y=[]
z=[]

t=k/2.0		#kot theta v radianih
while t<=math.pi:
	x=x+[t]			#dodaj tocko v risbo
	f=(1.0+math.cos(t))/2.0
	fe=f*math.sin(h*math.pi*math.sin(t))/(h*math.pi*math.sin(t))
	fh=f*math.cos(w*math.pi*math.sin(t))/(1.0-(w*2.0*math.sin(t))**2)
	y=y+[s*math.log(math.fabs(fe))]
	z=z+[s*math.log(math.fabs(fh))]
	t=t+k			#povecaj t za korak

import matplotlib.pyplot as plt		#risanje grafa funkcije
plt.plot(x,y,'r-',lw=2)
plt.plot(x,z,'b-',lw=2)
plt.grid(True)
plt.axis([0.0,math.pi,-40,2])
plt.xticks([0.0,math.pi/4,math.pi/2,3*math.pi/4,math.pi])
plt.yticks([-40,-35,-30,-25,-20,-15,-10,-5,0])
plt.ylabel('Logaritemsko merilo [dB]')
plt.show()

#konec programa

