#!/usr/bin/python
##### Smerni diagram Huygensovega izvora v polarnih koordinatah - S53MV 12.12.2017 #####

import math	#uporabljene funkcije

k=0.001		#korak risanja v radianih
s=0.5/math.log(10.0)
h=10.0		#visina lijaka v valovnih dolzinah
w=10.0		#sirina lijaka v valovnih dolzinah

xk=[]		#polja za risanje kroga
yk=[]
xfe=[]		#polja za risanje funkcije
yfe=[]
xfh=[]
yfh=[]

t=-math.pi+k/2.0	#kot theta v radianih
while t<=math.pi:
	xk=xk+[math.sin(t)]	#referencni enotni krog
	yk=yk+[math.cos(t)]
	f=(1.0+math.cos(t))/2.0	#izracun funkcije
	fe=f*math.sin(h*math.pi*math.sin(t))/(h*math.pi*math.sin(t))
	fh=f*math.cos(w*math.pi*math.sin(t))/(1.0-(w*2.0*math.sin(t))**2)
	le=s*math.log(math.fabs(fe))+1.0
	if le<0:
		le=0
	lh=s*math.log(math.fabs(fh))+1.0
	if lh<0:
		lh=0
	xfe=xfe+[math.sin(t)*le]	#risanje funkcije
	yfe=yfe+[math.cos(t)*le]
	xfh=xfh+[math.sin(t)*lh]
	yfh=yfh+[math.cos(t)*lh]
	t=t+k			#povecaj t za korak

import matplotlib.pyplot as plt		#risanje grafa funkcije
plt.plot(xk,yk,'g-',lw=1)		#referencni enotni krog
plt.plot([-1,1],[0,0],'g-',lw=1)	#koordinatne osi
plt.plot([0,0],[-1,1],'g-',lw=1)
plt.plot(xfe,yfe,'r-',lw=2)		#risanje funkcije
plt.plot(xfh,yfh,'b-',lw=2)		#risanje funkcije
plt.axis([-1.05,1.05,-1.05,1.05])
plt.xticks([])
plt.yticks([])
plt.title('Logaritemsko radialno merilo - razpon 40dB')
plt.xlabel('Os z')
plt.ylabel('Ravnina xy')
plt.axes().set_aspect('equal')
plt.show()

#konec programa

